//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PGPbuffers.h"
#include "PGPfiles.h"
#include "PGPfiles.h"
#include "PGPmail.h"
#include "fileman.h"
//---------------------------------------------------------------------------
// TPGPbuffer
//---------------------------------------------------------------------------
__fastcall TPGPbuffer::TPGPbuffer()
   : TBUFFER()
{
}
//---------------------------------------------------------------------------
__fastcall TPGPbuffer::TPGPbuffer(AnsiString keyringfile)
   : TBUFFER()
{
   filename = keyringfile;
   if (FileExists(filename))
   {
      BUFFER *buf=buf_new(),*armored=buf_new(),*keybuf=buf_new(),*asckeys=buf_new();
      buf_readfile(armored,filename.c_str());
      if (pgp_ispacketex(armored)) buf_move(keybuf,armored);
      else
      {
         while (GetNextPGPArmored(asckeys,armored))
         {
            pgpdearmor(asckeys,buf);
            buf_cat(keybuf,buf);
         }
      }
      Write(keybuf->data,keybuf->length);
      buf_free(asckeys);
      buf_free(armored);
      buf_free(keybuf);
      buf_free(buf);
   }
   rewind();
}
//---------------------------------------------------------------------------
__fastcall TPGPbuffer::TPGPbuffer(TStrings *asciiblock)
   : TBUFFER()
{
   import(asciiblock);
}
//---------------------------------------------------------------------------
void __fastcall TPGPbuffer::export(TStrings *asciiblock)
{
   BUFFER *asc = buf_new();
   buf_append(asc,data,length);
   pgparmor(asc,2);
   asciiblock->SetText((char*)asc->data);
   buf_free(asc);
}
//---------------------------------------------------------------------------
void __fastcall TPGPbuffer::import(TStrings *asciiblock)
{
   if (asciiblock->Count)
   {
      BUFFER *buf=buf_new(),*armored=buf_new(),*keybuf=buf_new(),*asckeys=buf_new();
      TStringList *keys = new TStringList();
      keys->Text = asciiblock->Text;
      while (keys->Count && !IsPGPArmoredHead(keys->Strings[0]))
         keys->Delete(0);

      if (keys->Count)
      {
         buf_sets(armored,asciiblock->Text.c_str());
         if (pgp_ispacketex(armored)) buf_move(keybuf,armored);
         else
         {
            while (GetNextPGPArmored(asckeys,armored))
            {
               pgpdearmor(asckeys,buf);
               buf_cat(keybuf,buf);
            }
         }
         Write(keybuf->data,keybuf->length);
      }
      buf_free(asckeys);
      buf_free(armored);
      buf_free(keybuf);
      buf_free(buf);
      delete keys;
   }
   rewind();
}
//---------------------------------------------------------------------------
__fastcall TPGPbuffer::TPGPbuffer(TPGPbuffer *buf)
   : TBUFFER()
{
   buf->rewind();
   copyfrom(buf);
   rewind();
}
//---------------------------------------------------------------------------
__fastcall TPGPbuffer::~TPGPbuffer()
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPGPbuffer::FirstUID()
{
   byte CTB;
   AnsiString uid;
   char buffer[256];
   long pktlen,Ptr=ptr;
   TPGPbuffer *buf = new TPGPbuffer();
   rewind(); while (buf->copypacketfrom(this))
   {
      pktlen = buf->GetPacketInfo(&CTB);
      if (UserIdPacket(CTB))
      {
         buf->Read(buffer,pktlen); buffer[pktlen]=0L;
         uid = buffer;
         break;
      }
      buf->clear();
   }
   ptr = Ptr;
   delete buf;
   return uid;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::keyexists(TPGPbuffer *key)
{
   long Ptr=ptr;
   bool exists = false;
   key->rewind(); rewind();
   TPGPbuffer *buf = new TPGPbuffer();
   while (buf->copykeyfrom(this))
   {
      if (buf->idtext8==key->idtext8)
      {
         exists = true;
         break;
      }
      buf->clear();
   }
   key->rewind();
   delete buf;
   ptr = Ptr;
   return exists;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::get(AnsiString IdText8, TPGPbuffer *key)
{
   long Ptr = ptr;
   bool got = false;
   rewind(); key->clear();
   while (key->copykeyfrom(this))
   {
      if (key->idtext8==IdText8)
      {
         key->rewind();
         got = true;
         break;
      }
      key->clear();
   }
   ptr = Ptr;
   return got;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPGPbuffer::getdescrips()
{
   TStringList *lines = new TStringList();
   getdescrips(lines);
   AnsiString desc = lines->Text;
   delete lines;
   return desc;
}
//---------------------------------------------------------------------------
void __fastcall TPGPbuffer::getdescrips(TStrings *lines)
{
   rewind();
   TPGPbuffer *key = new TPGPbuffer();
   while (key->copykeyfrom(this,REWIND))
   {
//sm("KEY: "+key->idtext8);
//sm("KEY LENGTH: "+s((int)key->length));
      lines->Add("0x"+key->idtext8+"  "+key->firstuid);
      key->clear();
   }
//sm(lines->Text);
   int i,len,hilen=0;
   for (i=0; i<lines->Count; i++)
   {
      len=lines->Strings[i].Length();
      if (len>hilen) hilen = len;
   }
   rewind();
   i = 0;
   while (key->copykeyfrom(this,REWIND))
   {
      AnsiString space,version,ispair,enabled,line;
      line = lines->Strings[i];
//sm(line);
      if (line.Length()<hilen+2) line += space.StringOfChar(32,(hilen+2)-line.Length());

      version = s(key->version)+"  ";
      enabled = key->enabled ? "enabled   ":"disabled  ";
      ispair = key->ispair ? "pair  ":"pub   ";
      lines->Strings[i] = line+version+ispair+enabled;
      key->clear();

      i++;
   }
   delete key;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::enable(bool Enable)
{
//sm(binstr(val)+"   "+binstr((val|32))+"   "+binstr((val^32)));
   bool gotit=false;
   TPGPbuffer *pkt = new TPGPbuffer();
   TPGPbuffer *key = new TPGPbuffer(this);
   key->rewind();
   clear();
   pkt->copypacketfrom(key,REWIND); // get key cert
   copyfrom(pkt);                   // copy to self
   pkt->clear();
   pkt->copypacketfrom(key,REWIND); // copy next--trust
   if (TrustPacket(pkt->CTB))
   {  // if it is a trust packet set enable to desired
      byte val = pkt->data[2];
      if ( Enable &&   (val&32)==32)  pkt->data[2] = (byte)(val^32); else
      if (!Enable && !((val&32)==32)) pkt->data[2] = (byte)(val^32);
   }
   else
   {
//    create a new trust packet
//      TPGPbuffer *buf = new TPGPbuffer();
//      byte trust[3] = { 176,1,(byte)(Enable?1:33) };
//      buf->Write(trust,3);
//      copyfrom(buf);
//      delete buf;
   }
   copyfrom(pkt); pkt->clear();
   while (pkt->copypacketfrom(key,REWIND))
   {
      copyfrom(pkt);
      pkt->clear();
   }
   delete key;
   delete pkt;
   return gotit;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::save()
{
   if (filename.IsEmpty()) return false;
   SaveToFile(filename);
   return true;
}
//---------------------------------------------------------------------------
int __fastcall TPGPbuffer::Count()
{
   long c=0,Ptr=ptr;
   rewind();
   TPGPbuffer *key = new TPGPbuffer();
   while (key->copykeyfrom(this))
   {
      key->clear();
      c++;
   }
   delete key;
   ptr = Ptr;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::IsPair()
{
   rewind();
   int pub=0,sec=0;
   TPGPbuffer *key = new TPGPbuffer();
   for (int i=0; i<2; i++)
   {
      if (key->copykeyfrom(this))
      {
         if (PublicKeyPacket(key->CTB)) pub++; else
         if (SecretKeyPacket(key->CTB)) sec++;
      }
      key->clear();
   }
   return pub>0 && sec>0;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::Enabled()
{
   bool enabled=true;
   TPGPbuffer *key = this;
   TPGPbuffer *pkt = new TPGPbuffer();

   key->rewind();
   pkt->copypacketfrom(key,REWIND); pkt->clear();
   pkt->copypacketfrom(key,REWIND);
   if (TrustPacket(pkt->CTB))
      enabled = !((pkt->data[2]&32)==32);
   delete pkt;
   return enabled;
}
//---------------------------------------------------------------------------
byte __fastcall TPGPbuffer::GetCTB()
{
   if (length) return *((byte*)&data[0]);
   return 0;
}
//---------------------------------------------------------------------------
byte __fastcall TPGPbuffer::ReadByte()
{
   byte b;
   Read(&b,1);
   return b;
}
//---------------------------------------------------------------------------
int __fastcall TPGPbuffer::ReadInt()
{
   int i;
   byte b[2];
   Read(b,2);
   i  = b[0] << 8;
   i += b[1];
   return i;
}
//---------------------------------------------------------------------------
long __fastcall TPGPbuffer::ReadLong()
{
   long l;
   byte b[4];
   Read(b,4);
   l  = b[0] << 24;
   l += b[1] << 16;
   l += b[2] << 8;
   l += b[3];
   return (l);
}
//---------------------------------------------------------------------------
int __fastcall TPGPbuffer::WriteByte(byte b)
{
   Write(&b,1);
   return 0;
}
//---------------------------------------------------------------------------
int  __fastcall TPGPbuffer::WriteInt(int i)
{
   WriteByte((byte)((i>>8)&255));
   WriteByte((byte)(i&255));
   return 0;
}
//---------------------------------------------------------------------------
int __fastcall TPGPbuffer::WriteLong(long l)
{
   WriteByte((byte)((l>>24)&255));
   WriteByte((byte)((l>>16)&255));
   WriteByte((byte)((l>>8)&255));
   WriteByte((byte)(l&255));
   return 0;
}
//---------------------------------------------------------------------------
byte __fastcall lolf(byte CTB)
{
   byte len=1;
   if ((CTB&1)==1) len = 2; else
   if ((CTB&2)==2) len = 4; else
   if ((CTB&3)==3) len = 0;
   return len;
}
//---------------------------------------------------------------------------
int  __fastcall TPGPbuffer::GetPacketSize()
{
   if (ptr>=length-1) return 0;

   long lol,len=0,l=0;
   byte CTB,tmp,*b=(byte*)&l;

   Read(&CTB,1); lol=lolf(CTB);
   Read(&l,lol);
   ptr -= lol+1;

   switch (lol)
   {
      case 1: len = *b; break;
      case 2: tmp=b[0]; b[0]=b[1]; b[1]=tmp; len = *(UINT*)&l; break;
      case 4: len = l; break;
   }
   if (len) len += lol+1;
   return len;
}
//---------------------------------------------------------------------------
int  __fastcall TPGPbuffer::GetPacketInfo(byte *CTB, byte *lol)
{
   int len,l=0;
   byte tmp,Lol,*b=(byte*)&l;

   rewind();
   Read(CTB,1); Lol=lolf(*CTB);
   Read(&l,Lol);
   switch (Lol)
   {
      case 1: len = *(byte*)&l; break;
      case 2: tmp=b[0]; b[0]=b[1]; b[1]=tmp; len = *(UINT*)&l; break;
      case 4: len =  l; break;
   }
   if (lol) *lol=Lol;
   return len;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::copyfrom(TPGPbuffer *buffer, int length)
{
   if (length<1)
   {
      length = buffer->length;
      buffer->rewind();
   }
   long maxlen=buffer->length-buffer->ptr;
   if (length>maxlen) length = maxlen;
   CopyFrom(buffer,length);

   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::copypacketfrom(TPGPbuffer *db, bool Rewind)
{
   if (db->ptr==db->length) return false;
   int len=db->GetPacketSize();
   if (!len) return false;
   copyfrom(db,len);
   if (Rewind) rewind();
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::EndOfKey()
{
   if (ptr==length) return false;
   byte ctb = *(char*)&data[ptr];
   return ctb==153 || ctb==149;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::copykeyfrom(TPGPbuffer *db, bool Rewind)
{
   long Ptr=db->ptr;
   if (Ptr==db->length) return false;
   while (copypacketfrom(db))
   {
      if (db->EndOfKey())
         break;
   }
   if (Rewind) rewind();
   return db->ptr>Ptr;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPbuffer::appendkeyfrom(TPGPbuffer *keys, bool Rewind)
{
   if (keys->ptr==keys->length) return false;
   Seek(0,soFromEnd);
   copykeyfrom(keys,Rewind);
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPGPbuffer::IdText8()
{
 	 byte c;
   AnsiString text8;
   TPGPbuffer *id = new TPGPbuffer();
   keyid(id);
	 for (int i=0; i<4; i++)
   {
 	  	 c = id->data[4+i];
		 text8 += "0123456789ABCDEF" [ c >> 4  ];
		 text8 += "0123456789ABCDEF" [ c & 0xf ];
	 }
   delete id;
   return text8;
}
//---------------------------------------------------------------------------
byte __fastcall TPGPbuffer::Version()
{
   return data[3];
}
//---------------------------------------------------------------------------
int __fastcall TPGPbuffer::keyid(TPGPbuffer *KeyId)
{
  long Ptr=ptr;
  byte version,algo,j;
  BUFFER *i = buf_new();
  BUFFER *k = buf_new();
  BUFFER *key = buf_new();
  buf_append(key,data+3,length-3); buf_rewind(key);

  switch (version=(byte)buf_getc(key))
  {
     case 2:
     case 3:
        buf_getl(key); // timestamp
        buf_geti(key); // validity
        buf_getc(key); // algo
        mpi_getex(key,i);
        break;
     case 4:
        buf_appendc(k, (char)version);
        buf_appendl(k, buf_getl(key));
        algo = (byte)buf_getc(key);
        buf_appendc(k, (char)algo);

        if (pgp_nummpiex(algo) == 0) buf_rest(k, key);
        else
           for (j = 0; j < pgp_nummpiex(algo); j++)
           {
	            mpi_getex(key,i);
 	            mpi_putex(k,i);
           }
        buf_clear(i);
        buf_appendc(i, 0x99);
        buf_appendi(i, k->length);
        buf_cat(i, k);
        digest_sha1ex(i, i);
        break;
  }
  KeyId->clear();
  KeyId->Write(&i->data[i->length-8],8);
  buf_free(key);
  buf_free(k);
  buf_free(i);
  ptr = Ptr;
  return 0;
}
//---------------------------------------------------------------------------
// Misc PGP routines for keyrings/keys
//---------------------------------------------------------------------------
void __fastcall SHA1ex(byte *b, int n, byte *m)
{
   _SHA1ex sha1;
   if ((sha1=(_SHA1ex)GetProcAddress(hSSLLib,"SHA1"))!=NULL) (sha1)(b,n,m);
}
//---------------------------------------------------------------------------
int __fastcall pgp_ispacketex(BUFFER *b)
{
  return ((b->data[b->ptr] >> 6) == 2 || (b->data[b->ptr] >> 6) == 3);
}
//---------------------------------------------------------------------------
int __fastcall pgp_nummpiex(int algo)
{
  switch (algo)
  {
     case PGP_ES_RSA: return (2);
     case PGP_S_DSA : return (4);
     case PGP_E_ELG : return (3);
  }
  return (0);
}
//---------------------------------------------------------------------------
int __fastcall digestmem_sha1ex(byte *b, int n, BUFFER *md)
{
  byte m[SHA_DIGEST_LENGTH];

  SHA1ex(b, n, m);
  buf_reset(md);
  buf_append(md, m, SHA_DIGEST_LENGTH);
  return (0);
}
//---------------------------------------------------------------------------
int __fastcall digest_sha1ex(BUFFER *b, BUFFER *md)
{
  return (digestmem_sha1ex(b->data, b->length, md));
}
//---------------------------------------------------------------------------
int __fastcall mpi_getex(BUFFER *b, BUFFER *mpi)
{
  buf_clear(mpi);
  int l=buf_geti(b);
  if (l <= 0 || b->ptr + (l + 7) / 8 > b->length) return (-1);
  buf_get(b, mpi, (l + 7) / 8);
  return (l);
}
//---------------------------------------------------------------------------
int __fastcall mpi_putex(BUFFER *buf, BUFFER *mpi)
{
  int l,i;
  l = mpi->length * 8;
  for (i = 7; i >= 0; i--)
    if (((mpi->data[0] >> i) & 1) == 1) {
      l -= 7 - i;
      break;
    }
  buf_appendi(buf, l);
  buf_cat(buf, mpi);
  return (l);
}
//---------------------------------------------------------------------------
int strleftex(const char *string, const char *keyword)
{
  register unsigned int i;

  for (i=0; keyword[i]!='\0'; i++)
     if (string[i] != keyword[i]) return 0;
  return 1;
}
//---------------------------------------------------------------------------
#define THEPOLY 0X1864CFB
// mode=0: normal message, 1: remailer message, 2: key 3: nym key 4: nym signature
int __fastcall pgparmor(BUFFER *in, int mode)
{
  BUFFER *out;
  unsigned long crc = 0xB704CE;
  long p;
  int i;

#if 0
  /* CRC algorithm from RFC 2440 */
  for (p = 0; p < in->length; p++) {
    crc ^= in->data[p] << 16;
    for (i = 0; i < 8; i++) {
      crc <<= 1;
      if (crc & 0x1000000)
	crc ^= THEPOLY;
    }
  }
#else
  /* pre-computed CRC table -- much faster */
  unsigned long table[256];
  unsigned long t;
  int q = 0;

  table[0] = 0;
  for (i = 0; i < 128; i++) {
    t = table[i] << 1;
    if (t & 0x1000000) {
      table[q++] = t ^ THEPOLY;
      table[q++] = t;
    } else {
      table[q++] = t;
      table[q++] = t ^ THEPOLY;
    }
  }
  for (p = 0; p < in->length; p++)
    crc = (crc << 8) ^ table[(in->data[p] ^ (crc >> 16)) & 255];
    //crc = crc << 8 ^ table[(in->data[p] ^ crc >> 16) & 255];
#endif
  encode(in, 64);

  out = buf_new();
  if (mode == 2 || mode == 3)
    buf_sets(out, begin_pgpkey);
  else if (mode == 4)
    buf_sets(out, begin_pgpsig);
  else
    buf_sets(out, begin_pgpmsg);
  buf_nl(out);
#if 1
  buf_appends(out, "Version: N/A\n");
#else
#ifdef MIMIC
  if (mode == 1 || mode == 3 || mode == 4)
    buf_appends(out, "Version: 2.6.3i\n");
  else
#endif
  {
    buf_appends(out, "Version: Mixmaster ");
    buf_appends(out, VERSION);
    buf_appends(out, " (OpenPGP module)\n");
  }
#endif
  buf_nl(out);
  buf_cat(out, in);
  buf_reset(in);
  buf_appendc(in, (byte)((crc >> 16) & 255));
  buf_appendc(in, (byte)((crc >> 8) & 255));
  buf_appendc(in, (byte)( crc & 255));
  encode(in, 0);
  buf_appendc(out, '=');
  buf_cat(out, in);
  buf_nl(out);
  if (mode == 2 || mode == 3)
    buf_appends(out, end_pgpkey);
  else if (mode == 4)
    buf_appends(out, end_pgpsig);
  else
    buf_appends(out, end_pgpmsg);
  buf_nl(out);

  buf_move(in, out);
  buf_free(out);
  return (0);
}
//---------------------------------------------------------------------------
int _fastcall pgpdearmor(BUFFER *in, BUFFER *out)
{
  BUFFER *line, *temp;
  int err;// = 0;
  int tempbuf = 0;

  line = buf_new();
  temp = buf_new();

  if (in == out) {
    out = buf_new();
    tempbuf = 1;
  }
  do
    if (buf_getline(in, line) == -1) {
      err = -1;
      goto end;
    }
  while (!strleftex((char*)line->data,"-----BEGIN PGP ")) ;

  while (buf_getheader(in, temp, line) == 0) ;	/* scan for empty line */

  /*err = */decode(in, out);
  err = buf_getline(in, line);
  if (line->length == 5 && line->data[0] == '=')	/* skip CRC */
    err = buf_getline(in, line);
  if (err == 0 && line->length && strleftex((char*)line->data,"-----END PGP "))
    err = 0;
  else
    err = -1;

end:
  buf_free(temp);
  buf_free(line);

  if (tempbuf) {
    buf_move(in, out);
    buf_free(out);
  }
  return (err);
}
//---------------------------------------------------------------------------
