#define _WINSOCKAPI_
//---------------------------------------------------------------------------
// see mixmastdlg.cpp for notes on load-time vs run-time binding
// MixDir() is in global.cpp
#ifndef PgpDlgsH
#define PgpDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>

#include "FileMan.h"
#include "mixmaster.h"
#include "global.h"
//---------------------------------------------------------------------------
const int mPGPsign = 1;
const int mPGPencrypt = 2;
const int mPGPencryptc = 3;
const int mPGPencryptsign = 5;
const int mPGPdecrypt = 6;
const int mPGPdecryptc = 7;
const int mPGPverify = 8;

const AnsiString tmpSecring = GetTempDir()+"secring.pkr";
const AnsiString tmpPubring = GetTempDir()+"pubring.pkr";
const AnsiString tmpRemring = GetTempDir()+"Remring.pkr";

class TPgpDlg : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TButton *CancelBtn;
  TTimer *Timer1;
  TTimer *Timer2;
  TTimer *Timer3;
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall Timer3Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
  BUFFER *dat,*pas,*enc,*sig;
  bool *Cancelled,ClearSign,ToRemailer;
  int Mode,Result;
  int MsgCount;
  TStrings *TheText;
  TStrings *TheRecips; // encrypt to these keys
  AnsiString *Passphrase;
  TProgressBar *ProgressBar;
  AnsiString Cap,Filename,SKeyRing,PKeyRing,RKeyRing,NewExt;
  TStringList *Feedback,*Messages,*Topper;
  TForm *MainForm;
  virtual __fastcall TPgpDlg(TComponent* Owner);
  virtual __fastcall TPgpDlg(AnsiString PubRing, AnsiString SecRing, AnsiString RemRing,
     TForm* MainForm);
  virtual __fastcall ~TPgpDlg();
  int __fastcall Execute(int mode);
  void __fastcall PGPerror(AnsiString &ErrorStr, AnsiString Title="PGP Error");
  int __fastcall SignMessage(TStrings *Message, AnsiString &SigId, AnsiString &Passphrase);
  int __fastcall EncryptMessage(TStrings *Message, TStrings *Recips);
  int __fastcall EncryptCMessage(TStrings *Message, AnsiString &Passphrase);
  int __fastcall EncryptSignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &Passphrase, TStrings *Recips, bool Clearsign);
  int __fastcall DecryptMessage(BUFFER *Message, AnsiString &Passphrase);
  int __fastcall VerifyMessage(BUFFER *Message, BUFFER *Signature);
  bool __fastcall IsRemailed(TStrings *Recips);
  // lower level
  int __fastcall PgpEncryptFile();
  int __fastcall PgpDecryptFile();
  int __fastcall PgpEncryptConventional();
  int __fastcall PgpDecryptConventional();
  int __fastcall PgpEncryptSignMessage();
//  int __fastcall PgpSignMessage();
};

#define BUFWORD "7դxcQ'QhV15+acn*>GrH{#"
//---------------------------------------------------------------------------
extern TPgpDlg *PgpDlg;
//---------------------------------------------------------------------------
#endif
