//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpsdk.h"
#include "global.h"
#include "pgpmail.h"
#include "fmxutils.h"
#include "fileman.h"
HINSTANCE hPgpSdk=NULL;
//---------------------------------------------------------------------------
bool  __fastcall HasSdk()
{
   return hPgpSdk!=NULL;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCheckPGP6NeedsUpdate(TForm *Owner, TControl *ForHourGlass)
{
   if (!PGP6AUTOIMPORT) return false;

   int QDKpub = FileAge(PGPqdkPubringpkr()); // QDK = sdk keyrings
   int PGPpub = FileAge(PgpPublicRing());    // quicksilver keyrings
   int QDKsec = FileAge(PGPqdkSecringskr());
   int PGPsec = FileAge(PgpSecretRing());

   if (QDKpub<0 || QDKsec<0) return false;   // -1 returned if file does not exist
   if (PGPpub<0 || PGPsec<0 || QDKpub>PGPpub || QDKsec>PGPsec)
   {
      PGPqdkUpdateQSKeyrings(Owner,ForHourGlass);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkUpdateQSKeyrings(TForm *Owner, TControl *ForHourGlass)
{
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Updating PGP keyrings on disk...");
   if (ForHourGlass) ForHourGlass->Cursor = crHourGlass;
   if (!PGPqdkCopyCompat5(Owner->Handle,PgpPublicRing().c_str(),PgpSecretRing().c_str()))
   {
      if (ForHourGlass) ForHourGlass->Cursor = crDefault;
      MsgBoxHwnd(Owner->Handle,"Failed to import keys!","File Error",MB_OK);
      return false;
   }
   //remove backup keyrings PGP6 maintains it's own
   TStringList *tmp =new TStringList();
   TStringList *files=new TStringList();
   AnsiString QSKeyringPath = ExtractFilePath(PgpPublicRing());
   GetFilenames(files,QSKeyringPath+"pubring-bak-*.*",faAnyFile);
   GetFilenames(tmp,QSKeyringPath+"secring-bak-*.*",faAnyFile);
   files->AddStrings(tmp);
   for (int i=0; i<files->Count; i++)
      DeleteFile(files->Strings[i].c_str());
   delete files;
   delete tmp;
   //reverse earlier visual cues
   if (ForHourGlass) ForHourGlass->Cursor = crDefault;
   //if (Owner) Owner->Caption = cap;
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"QuickSilver keyrings updated");
   return true;
}
//---------------------------------------------------------------------------
// Imported QSpgp6.dll functions
//---------------------------------------------------------------------------
bool __fastcall PGPqdkInit(HWND owner, HWND apphandle)
{
   bool ok=true;
   PGPQDKINIT pgpinit;
   if ((pgpinit = (PGPQDKINIT)GetProcAddress(hPgpSdk,"@PGPqdkInit"))!=NULL)
      ok = (pgpinit)(owner,apphandle);
   if (!ok && hPgpSdk)
   {
      FreeLibrary(hPgpSdk);
      hPgpSdk = NULL;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall PGPqdkCleanup()
{
   PGPQDKCLEANUP pgpdone;
   if ((pgpdone=(PGPQDKCLEANUP)GetProcAddress(hPgpSdk,"@PGPqdkCleanup"))!=NULL)
      (pgpdone)();
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkCopyCompat5(HWND owner, char *pubring, char *secring)
{
   PGPQDKCOPYCOMPAT5 copy5;
   if ((copy5=(PGPQDKCOPYCOMPAT5)GetProcAddress(hPgpSdk,"@PGPqdkCopyCompat5"))!=NULL)
       return (copy5)(owner,pubring,secring);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkEnableKeys(HWND Owner, PGPKeySetRef keys, char *HexID)
{
   PGPQDKENABLEKEYS ablekeys;
   if ((ablekeys=(PGPQDKENABLEKEYS)GetProcAddress(hPgpSdk,"@PGPqdkEnableKeys"))!=NULL)
       return (ablekeys)(Owner,keys,HexID);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkDeleteKeys(HWND Owner, PGPKeySetRef keys, char *HexID)
{
   PGPQDKDELETEKEYS delkeys;
   if ((delkeys=(PGPQDKDELETEKEYS)GetProcAddress(hPgpSdk,"@PGPqdkDeleteKeys"))!=NULL)
       return (delkeys)(Owner,keys,HexID);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PGPqdkImportKeys(HWND Owner, PGPKeySetRef keys, char *asciiblock)
{
   PGPQDKIMPORTKEYS impkeys;
   if ((impkeys=(PGPQDKIMPORTKEYS)GetProcAddress(hPgpSdk,"@PGPqdkImportKeys"))!=NULL)
       return (impkeys)(Owner,keys,asciiblock);
   return false;
}
//---------------------------------------------------------------------------
char*__fastcall PGPqdkExportKeys(HWND Owner, PGPKeySetRef keys, char *HexIDs,
   PGPExportFormat &ExpFormat)
{
   PGPQDKEXPORTKEYS expkeys;
   if ((expkeys=(PGPQDKEXPORTKEYS)GetProcAddress(hPgpSdk,"@PGPqdkExportKeys"))!=NULL)
       return (expkeys)(Owner,keys,HexIDs,ExpFormat);
   return NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PGPqdkPubringpkr()
{
   PGPQDKPUBRING qdkpub;
   if ((qdkpub=(PGPQDKPUBRING)GetProcAddress(hPgpSdk,"@PGPqdkPubringpkr"))!=NULL)
      return AnsiString((qdkpub)());
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall PGPqdkSecringskr()
{
   PGPQDKSECRING qdksec;
   if ((qdksec=(PGPQDKSECRING)GetProcAddress(hPgpSdk,"@PGPqdkSecringskr"))!=NULL)
      return AnsiString((qdksec)());
   return "";
}
//---------------------------------------------------------------------------
